# File: DynLabel.py
"""\
unknown

RCS-ID $Id: DynLabel.py,v 1.1 2005/04/07 06:18:27 zope Exp $
"""
# Copyright (c) 2005-2007 by N Laurance
#
# Generated: Wed Mar 30 19:14:39 2005
# Generator: ArchGenXML Version 1.2 devel 1 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = 'N Laurance <nlaurance@zindep.com>'
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from Products.ATContentTypes.content.schemata import ATContentTypeSchema
from Products.ATContentTypes.content.schemata import finalizeATCTSchema
from Products.ATContentTypes.content.base import registerATCT
from Products.ATContentTypes.content.base import updateActions
from Products.Archetypes.BaseContent import BaseContent
from Products.ATContentTypes.content.base import ATCTContent

##code-section module-header #fill in your manual code here
#from ColorWidget import ColorWidget
#from ColorValidator import ColorValidator
from Products.ATColorPickerWidget.ColorPickerWidget import ColorPickerWidget

       
from Products.CMFCore.utils import getToolByName

from config import *

from reportlab.graphics.shapes import *
from reportlab.graphics.charts.textlabels import Label
from reportlab.graphics.renderPM import drawToString

import md5, base64, time
from string import replace,strip
##/code-section module-header

schema= Schema((
    IntegerField('topPadding',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for topPadding.',
            description_msgid='DynLabels_help_topPadding',
            i18n_domain='DynLabels',
            label='Toppadding',
            label_msgid='DynLabels_label_topPadding',
        ),
    ),
    
    IntegerField('rightPadding',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for rightPadding.',
            description_msgid='DynLabels_help_rightPadding',
            i18n_domain='DynLabels',
            label='Rightpadding',
            label_msgid='DynLabels_label_rightPadding',
        ),
    ),
    
    IntegerField('bottomPadding',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for bottomPadding.',
            description_msgid='DynLabels_help_bottomPadding',
            i18n_domain='DynLabels',
            label='Bottompadding',
            label_msgid='DynLabels_label_bottomPadding',
        ),
    ),
    
    IntegerField('leftPadding',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for leftPadding.',
            description_msgid='DynLabels_help_leftPadding',
            i18n_domain='DynLabels',
            label='Leftpadding',
            label_msgid='DynLabels_label_leftPadding',
        ),
    ),
    
    StringField('textAnchor',
        default='''start''',
        schemata='''position''',
        vocabulary=TEXTANCHOR_LIST,
        widget=SelectionWidget
        (description='Enter a value for textAnchor.',
            description_msgid='DynLabels_help_textAnchor',
            i18n_domain='DynLabels',
            label='Textanchor',
            label_msgid='DynLabels_label_textAnchor',
        ),
    ),
    
    StringField('boxAnchor',
        default='''sw''',
        schemata='''position''',
        vocabulary=BOXANCHOR_LIST,
        widget=SelectionWidget
        (description='Enter a value for boxAnchor.',
            description_msgid='DynLabels_help_boxAnchor',
            i18n_domain='DynLabels',
            label='Boxanchor',
            label_msgid='DynLabels_label_boxAnchor',
        ),
    ),
    
    IntegerField('angle',
        schemata='''definition''',
        default=0,
        widget=IntegerWidget(description='Enter a value for angle, fix point is rotation point',
            description_msgid='DynLabels_help_angle',
            i18n_domain='DynLabels',
            label='Angle',
            label_msgid='DynLabels_label_angle',
        ),
    ),
    
    IntegerField('x',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for x, horizontal position of fix point.',
            description_msgid='DynLabels_help_x',
            i18n_domain='DynLabels',
            label='X',
            label_msgid='DynLabels_label_x',
        ),
    ),
    
    IntegerField('y',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for y, vertical position of fix point.',
            description_msgid='DynLabels_help_y',
            i18n_domain='DynLabels',
            label='Y',
            label_msgid='DynLabels_label_y',
        ),
    ),
    
    IntegerField('dx',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for dx, horizontal space between fix point ans start of text.',
            description_msgid='DynLabels_help_dx',
            i18n_domain='DynLabels',
            label='Dx',
            label_msgid='DynLabels_label_dx',
        ),
    ),
    
    IntegerField('dy',
        schemata='''position''',
        default=0,
        widget=IntegerWidget(description='Enter a value for dy, vertical space between fix point ans start of text.',
            description_msgid='DynLabels_help_dy',
            i18n_domain='DynLabels',
            label='Dy',
            label_msgid='DynLabels_label_dy',
        ),
    ),
    
    StringField('fontName',
        schemata='''definition''',
        vocabulary=font_list(),
        widget=SelectionWidget
        (description='Enter a value for fontName.',
            description_msgid='DynLabels_help_fontName',
            i18n_domain='DynLabels',
            label='Fontname',
            label_msgid='DynLabels_label_fontName',
        ),
    ),
    
    IntegerField('fontSize',
        schemata='''definition''',
        default=18,
        widget=IntegerWidget(description='Enter a value for fontSize.',
            description_msgid='DynLabels_help_fontSize',
            i18n_domain='DynLabels',
            label='Fontsize',
            label_msgid='DynLabels_label_fontSize',
        ),
    ),
    
    StringField('fillColor',
        default='''#000000''',
        schemata='''definition''',
        widget=ColorPickerWidget
        (description='Enter a value for fillColor.',
            description_msgid='DynLabels_help_fillColor',
            i18n_domain='DynLabels',
            label='Fillcolor',
            label_msgid='DynLabels_label_fillColor',
        ),
    ),
    
    StringField('strokeColor',
        schemata='''definition''',
        default='''#FFFFFF''',
        widget=ColorPickerWidget
        (description='Enter a value for strokeColor.',
            description_msgid='DynLabels_help_strokeColor',
            i18n_domain='DynLabels',
            label='Strokecolor',
            label_msgid='DynLabels_label_strokeColor',
        ),
    ),
    
    FloatField('strokeWidth',
        schemata='''definition''',
        default=1.0,
        widget=DecimalWidget(description='Enter a value for strokeWidth.',
            description_msgid='DynLabels_help_strokeWidth',
            i18n_domain='DynLabels',
            label='Strokewidth',
            label_msgid='DynLabels_label_strokeWidth',
        ),
    ),
    
    StringField('background_color',
        default='''#FFFFFF''',
        schemata='''definition''',
        widget=ColorPickerWidget
        (description='Enter a value for background_color.',
            description_msgid='DynLabels_help_background_color',
            i18n_domain='DynLabels',
            label='Background_color',
            label_msgid='DynLabels_label_background_color',
        ),
    ),
    
    IntegerField('width',
        schemata='''definition''',
        default=160,
        widget=IntegerWidget(description='Enter a value for width, in pixels.',
            description_msgid='DynLabels_help_width',
            i18n_domain='DynLabels',
            label='Width',
            label_msgid='DynLabels_label_width',
        ),
    ),
    
    IntegerField('height',
        schemata='''definition''',
        default=25,
        widget=IntegerWidget(description='Enter a value for height, in pixels.',
            description_msgid='DynLabels_help_height',
            i18n_domain='DynLabels',
            label='Height',
            label_msgid='DynLabels_label_height',
        ),
    ),
    
),
)


DynLabelSchema = ATContentTypeSchema.copy() + \
    schema

finalizeATCTSchema(DynLabelSchema)

class DynLabel(BaseContent):
    security = ClassSecurityInfo()
    portal_type = meta_type = 'DynLabel' 
    archetype_name = 'DynLabel'   #this name appears in the 'add' box 
    allowed_content_types = [] 
    schema=DynLabelSchema
    _at_rename_after_creation = True # rename object according to the title?


    #Methods
    cache={}
    security.declareProtected('''View''','translate_message')
    def translate_message(self,msgid,domain="plone",text=""):
        pts=getToolByName(self,'translation_service',None)
        if pts is None:
            return ''
        _=pts.utranslate
        #import pdb; pdb.set_trace()
        value = _(domain,msgid,context=self,default=text)
        return pts.encode(value, errors='replace')


    security.declareProtected('''View''','__call__')
    def __call__(self,text='zindep',msgid='',domain='plone'):
        """
        returns either a cached value or calculate a new image
        and set it in local cache before return
        """

        # simple cache mechanism
        digest=md5.new()
        mdstr=''
        #import pdb; pdb.set_trace()
        for f in self.schema.fields():
              mdstr=mdstr+str(f.get(self))
        if msgid:
            text=self.translate_message(msgid,domain,text)
        digest.update(mdstr+text)
        digest=digest.digest()
        digest=strip(base64.encodestring(digest))
        if self.cache.has_key(digest):
            self.cache[digest]['last_access']=time.time()
            self.cache[digest]['hits']=self.cache[digest]['hits']+1
            return self.cache[digest]['data']

        #if no cache yet, calculate image
        from reportlab.lib import colors
        drawing = Drawing(self.width, self.height)

        lab = Label()
        lab.topPadding = self.topPadding
        lab.rightPadding = self.rightPadding
        lab.bottomPadding = self.bottomPadding
        lableftPadding = self.leftPadding
        lab.textAnchor = self.textAnchor # start, middle, end
        lab.boxAnchor = self.boxAnchor # c, ne, n , nw, w ...
        lab.angle = self.angle # inclinaison du widget
        lab.x = self.x
        lab.y = self.y
        lab.dx = self.dx
        lab.dy = self.dy
        lab.fontName = self.fontName.encode('utf-8') 
        lab.fontSize = self.fontSize
        #import pdb; pdb.set_trace()
        lab.fillColor = colors.HexColor(self.fillColor.encode('utf-8'))
        lab.strokeColor = colors.HexColor(self.strokeColor.encode('utf-8'))
        lab.strokeWidth = self.strokeWidth
        lab.setText(text)
        drawing.add(lab)
        # Create Image and returns to zope
        background_color= colors.HexColor(self.background_color.encode('utf-8'))
        data = drawToString(drawing,fmt='JPEG',bg=background_color, )
        # set cache
        self.cache[digest]={'last_access':time.time(),
                            'hits':1,
                            'data':data}
        return data

    #manually created methods

    def VOC_COLORS(self):
        '''
        list of named colors
        '''
        
        from config import color_list
        return DisplayList(color_list)

    def VOC_FONTS(self):
        '''
        list of registered fonts
        '''
        
        from config import font_list
        return DisplayList(font_list)



    # uncomment lines below when you need
    factory_type_information={
        'allowed_content_types':allowed_content_types,
        'allow_discussion': 0,
        'content_icon':'icon_dynlabel.gif',
        'immediate_view':'render',
        'global_allow':1,
        'filter_content_types':1,
        }

        
    actions=  (
        

       {'action':      '''string:$object_url/render''',
        'category':    '''object''',
        'id':          'render',
        'name':        'render',
        'permissions': ('''View''',),
        'condition'  : 'python:1'},
        

          )
        

registerType(DynLabel)
# end of class DynLabel