from reportlab.lib.utils import _findFiles
from reportlab.rl_config import TTFSearchPath

from reportlab.pdfbase.pdfmetrics import getRegisteredFontNames, registerFont
from reportlab.pdfbase.ttfonts import TTFont, TTFontFace

from string import split
#from Products.CMFCore.CMFCorePermissions import ManagePortalContent

from Products.Archetypes.public import DisplayList

FONTLIST = [] 
COLORLIST = []
TEXTANCHOR_LIST=DisplayList((
                          ('start','start'),
                          ('middle','middle'),
                          ('end','end'),
                           ))

BOXANCHOR_LIST=DisplayList((
                          ('c','Center'),
                          ('n','North'),
                          ('nw','North West'),
                          ('w','West'),
                          ('sw','South West'),
                          ('s','South'),
                          ('se','South East'),
                          ('e','East'),
                          ('ne','North East'),
                           ))

#ADD_CONTENT_PERMISSION = ManagePortalContent


def font_list():
    """
    returns list of available fonts
    """
    try: 
        return FONTLIST
    except :
        for fontfile in  _findFiles(TTFSearchPath, '.ttf'):
            try:
                face=TTFontFace(fontfile)
            except:
                pass
            try:
                font=TTFont(face.name,fontfile)
            except:
                pass
            try:
                registerFont(font)
            except:
                pass
        FONTLIST=getRegisteredFontNames()
        return FONTLIST

def namedcolor_list():
    """
    returns list of (named color, html code)
    """
    try:
        return COLORLIST
    except:
        f=open('named_colors.conf')
        COLORLIST=[]
        for l in f.readlines():
            (colorName,colorCode)=split(l,'\t')
            COLORLIST.append((colorName,colorCode[:-1])) # supress \n
        f.close()
        return COLORLIST

def test():
    print font_list()
    print '='*30
    print namedcolor_list()


if __name__ == '__main__' :
    test()
